import { Fields, Fn, UpdateOperation } from "../types/Anilist.ts"
import { MediaListGroup } from "./Media.ts"

export const MediaListCollection = ({ query, level }: Fields<UpdateOperation>) => ({
  /** Grouped media list entries */
  withLists(fn: Fn<typeof MediaListGroup>) {
    query[0] = query[0].set({ subField: "lists", level, hasSubField: true })
    let tmpQuery
    fn(MediaListGroup({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
  /** The owner of the list */
  withUser() {
    query[0] = query[0].set({ subField: "user", level })
    return this
  },
  /** If there is another chunk */
  withHasNextChunk() {
    query[0] = query[0].set({ subField: "hasNextChunk", level })
    return this
  },
})
